--[[ LOAD ]]--

local st = {}
local percent

function st:init()
	st['finished'] = false
	percent = 0
end

function st:enter()
	if DEBUG == true then print('Enter LOAD') end
	VIDEO.intro:play()
end

function st:update(dt)
	PERFORMANCEGRAPH:preUpdate()

	LOADER.update()

	if st.finished and not VIDEO.intro:isPlaying() then
		GS.switch(STATE.MENU)
	end
	PERFORMANCEGRAPH:postUpdate()
end

function st:draw()
	PERFORMANCEGRAPH:preDraw()
	love.graphics.draw(VIDEO.intro, (LG.getWidth() - VIDEO.intro:getWidth())/2, (LG.getHeight() - VIDEO.intro:getHeight())/2)
	if LOADER.resourceCount ~= 0 then percent = LOADER.loadedCount / LOADER.resourceCount end
	love.graphics.print(("Loading .. %d%%"):format(percent*100), 50, LG.getHeight() - 50)
	PERFORMANCEGRAPH:postDraw()
end

function st:keyreleased(key)
	if key == 'return' or key == 'escape' then
		VIDEO.intro:pause()
	end
end

function st:leave()
	if DEBUG == true then print('Leave LOAD') end
end

return st