--[[ MENU ]]--

local st = {}

local suit, menu

function st:init()
	suit = require 'lib/SUIT'
	
	--MUSIC.song:setVolume(0.25)
	--MUSIC.song:play()
end

function st:enter(_)
	if DEBUG == true then print('Enter MENU') end
	menu = suit.new()	
end

function st:update(dt)
	PERFORMANCEGRAPH:preUpdate()
	local bw, bh = 400, 100

	menu.layout:reset((LG.getWidth() - bw)/2, bh)

	menu:Label("Guard Dog", {font=FONT.header}, menu.layout:row(bw, bh))
	
	menu.layout:padding(10, LG.getHeight()/4)

	local bstart = menu:Button("Start", {font=FONT.big}, menu.layout:row(bw, bh))
	if bstart.hit then
		GS.switch(STATE.GAME)
	end
	
	menu.layout:padding(10, 10)

	if menu:Button("Exit", {font=FONT.big}, menu.layout:row(bw, bh)).hit then
		love.event.quit()
	end
	
	menu:Label("Press 'S' or 'Return' to continue", menu.layout:row())
	PERFORMANCEGRAPH:postUpdate()
end

function st:draw()
	PERFORMANCEGRAPH:preDraw()
	menu:draw()

	love.graphics.print("State: MENU", 50, LG.getHeight() - 50)
	PERFORMANCEGRAPH:postDraw()
end

function st:textinput(t)
	suit.textinput(t)
end

function st:keypressed(key)
	suit.keypressed(key)
end

function st:keyreleased(key)
	--suit.keyreleased(key) -- does not exist in SUIT
	
	if key == 'escape' then
		love.event.quit()
	end
	
	if key == 's' or key == 'return' then
		GS.switch(STATE.GAME)
	end
end

function st:leave()
	if DEBUG == true then print('Leave MENU') end
end

return st
